模块三:二分——LCR. 173.点名

文章目录

题目描述

题目链接:LCR. 173.点名

关于这道题中,时间复杂度为 O(N) 的解法有很多种,⽽且也是⽐较好想的,这⾥就不再赘述。本题只讲解⼀个最优的⼆分法和一个暴力版本,来解决这个问题。

算法原理

暴力查找

遍历一遍数组,寻找recordsi != i的位置,返回下标i即可,循环结束还没有返回结果就是数组的长度了。

二分查找

在这个升序的数组中,我们发现:

  • 在第⼀个缺失位置的左边,数组内的元素都是与数组的下标相等的;
  • 在第⼀个缺失位置的右边,数组内的元素与数组下标是不相等的。

因此,我们可以利⽤这个「⼆段性」,来使⽤「⼆分查找」算法。
PS:这里有个细节问题是当答案为数组长度时,即只有两个数时,根据判断条件left会等于recordsright,这个答案显然是错误的,所以需要处理一下。

代码实现

暴力查找

cpp 复制代码
class Solution {
public:
    int takeAttendance(vector<int>& records) {
        for(int i = 0;i < records.size();i++){
            if(records[i] != i)
                return i;
        }
        return records.size();
    }
};

二分:C++

cpp 复制代码
class Solution {
public:
    int takeAttendance(vector<int>& records) {
        int left = 0,right = records.size() - 1;
        while(left < right){
            int mid = left + (right - left) / 2;
            if(records[mid] == mid)left = mid + 1;
            else right = mid;
        }
        //处理细节问题
        return (records[left] == left) ? left + 1 : left;
    }
};

Java

java 复制代码
class Solution {
    public int missingNumber(int[] nums) {
        int left = 0, right = nums.length - 1;
        while (left < right) {
            int mid = left + (right - left) / 2;
            if (nums[mid] == mid)
                left = mid + 1;
            else
                right = mid;
        }
        return left == nums[left] ? left + 1 : left;
    }
}
相关推荐
凤凰院凶涛QAQ3 小时前
《Java版数据结构 & 集合类剖析》Map & Set & 反射:“从哈希碰撞到红黑树转换,反射帮你扒开 HashMap 的桶数组看个究竟”
java·数据结构·算法
w_zero_one4 小时前
算法--模拟
java·数据结构·算法
秋天的怀念_David5 小时前
算法一千零一夜 · 第十三夜 幻方,武侠世界里的数学迷宫
java·程序人生·算法
·present·5 小时前
CSAPP(lecture 4_01)
c语言·c++
FPGA小迷弟5 小时前
用 Claude Code 重构遗留系统:从评估到落地的完整实践指南
c++·python·ai·plotly·django·ai编程·claude
秋天的怀念_David5 小时前
算法一千零一夜 · 第十四夜 幻方与奇妙的二进制
java·程序人生·算法
薛定e的猫咪6 小时前
(ICLR 2020)MAML 靠的不是快速学习,而是特征复用
人工智能·深度学习·学习·算法·机器学习
程序员-King.6 小时前
【ROS1】Noetic 开发工作流程与常用命令
c++·ubuntu·ros
云深麋鹿6 小时前
C++ | 基于红黑树实现mymap与myset
开发语言·c++
薛定e的猫咪6 小时前
(ICLR 2026)DF-META:面向 FJSP 的无导数元学习实例自适应调度
人工智能·深度学习·学习·算法·机器学习